/*  File:   main.c 1
 * gakufu ́A16 bit PʁB
 * ŏɃe|(1Ԃɉtl̐jL^ĂB
 * ȍ~͉ MSB 8 bit̍B PʂŁÃh 60(0x3C)
 *                LSB 8 bit̒
 *     񕪉F10A    lF08A    F04A    \ZF02
 * t_񕪉F18At_lF0CAt_F06At_\ZF03
 *      | 7 6 5 4 3 2 1 0| 7 6 5 4 3 2 1 0 |
 *      |            |             |
 *     Language: MPLABX XC8
 *     Target: PIC116F1459
 */
// x  wl(ms)1/16
#define EnvelopeConst 50
// Ɖ̊Ԃ̖(ms)
#define Silent        30

#include "xc.h"
#include "gakufu.h"
#define _XTAL_FREQ 48000000
#define SW2        RA5
#define SPK        LATC6
#define TRIS_SPK   TRISC6
#define TRIS_LED3  TRISC2
#define LED3       LATC2
#define waitStart  0
#define getGakufu  1
#define getOnpu    2
#define onpuStart  3
#define onpuPlay   4
#define onpuEnd    5
#define gkfEnd     6

#pragma config FOSC  = INTOSC, WDTE = OFF, PWRTE = OFF, MCLRE = OFF, CP  = OFF
#pragma config BOREN = ON, CLKOUTEN = OFF, IESO  = OFF, FCMEN = OFF
#pragma config WRT = OFF, CPUDIV = NOCLKDIV, USBLSCLK = 48MHz, PLLMULT = 3x
#pragma config PLLEN = ENABLED, STVREN = ON, BORV = LO, LPBOR = OFF, LVP = OFF

// for 48MHz Fosc   PWM Freq 93.75kHz
const unsigned int dW_tbl[] = { 
//  Do,   Do#,  Re,   Re#,  Mi,   Fa,   Fa#,  So,   So#,  Ra,   Ra#,  Si,
    0,
    0x05B,0x061,0x067,0x06D,0x073,0x07A,0x081,0x089,0x091,0x09A,0x0A3,0x0AD,
    0x0B7,0x0C2,0x0CD,0x0D9,0x0E6,0x0F4,0x103,0x112,0x122,0x134,0x146,0x159,
    0x16E,0x184,0x19B,0x1B3,0x1CD,0x1E8,0x205,0x224,0x245,0x267,0x28C,0x2B2,
    0x2DC,0x307,0x335,0x366,0x39A,0x3D1,0x40B,0x448,0x489,0x4CE,0x517,0x565
};
unsigned int accWave,incWave;
unsigned char amp,wave;

void main(void) {
    char SWdown=0;           // SW ̃tO
    char SWnotRdy=0;         // SW `^Oh~
    char state = 0;          // Xe[g
    unsigned int pOnp;       // ʒu
    unsigned int Onp;        // 
    unsigned char tempo;     // e|
    unsigned char tPlay;     // t
    char AmpCnt = 25;        // U
    char TmpCnt = 65;        // e|
    char TmpFlg = 0;         // e|tO 
    char SltCnt = 20;        //  
    char SltFlg = 0;         // tO 
    char ampNext;            //  

    OSCCON = 0b11111100;     // SPLLEN = ON, 16MHz(x3=48MHz)
    TRIS_SPK = 0;            // SPK RA2 o
    SPK = 0;                 // SPK óu0]
    TRIS_LED3 = 0;           // LED3 RC2 o
    LED3 = 0;                // LED3 
    nWPUEN = 0;              // vAbv L
    // Timer1 ̐ݒ -------------------------
    T1CON = 0b00000001;                 // Fosc/4 ps 1/1 TMR1ON
    TMR1 = 0xD100;                      // +12032 (1ms)  Carry
    TMR1IF = 0;                         // Timer1tONA
    // PWM ̐ݒ -------------------------
    PWM2DCL = 0;
    PR2 = 0x7F;                         // Freq_PWM = 93.75kHz
    T2CON = 0b00000000;                 // Fosc/4 ps 1/1 T2OFF
    TMR2IF = 0;                         // Timer2tONA
    TMR2IE = 1;                         // Timer2ݗL
    PEIE = 1;                           // ytFݗL
    GIE = 1;                            // ݗL
    while(1){
        while(!TMR1IF);                 // 1ms  Carry
        TMR1H = 0xD1;                   //  1ms ݒ
        TMR1IF = 0;
        //------- SW`^Oh~ 1ms[v ----------------
        if(SWnotRdy){                   // SWup̊mFȂ
            if(SW2)SWnotRdy--;          //   SWup̊mF[P
              else SWnotRdy=5;          //   SWup̊mFl
        }else if(!SW2){                 // SWup̊mFς݂DownȂ
                SWdown=1;               //   SWꂽ}[N
                SWnotRdy=5;             //   SWup̊mF҂
        }
        //------- U 50ms -----------------------------------
        if(AmpCnt-- == 1){
            AmpCnt = EnvelopeConst;     // ʂ 50ms
            amp = (int)amp * 15/16;     // ʂ -6% 
        }
        //------- e| -----------------------------------
        if(TmpCnt-- == 1){
            TmpCnt = tempo;             // e|
            TmpFlg = 1;                 // e|tOZbg
        }
        //------- Silent -----------------------------------
        if(SltCnt-- == 1){              // ԂɂȂ
            SltFlg = 1;                 // tOZbg
        }
        //---------------------------------------------------------
        switch(state){
            case waitStart:             // ====== tJn҂ ======
                if(SWdown){                       // SW ̂҂
                    SWdown=0;                     // SW ςݖ
                    state = getGakufu;
                }
                break;
            case getGakufu:             // ====== y̐ݒ ======
                    tempo = 7500/p1gkf[0];        // ỹe|擾
                    pOnp = 1;                     // ̊Jn|Cg
                    PWM2CON = 0b11000000;         // PWM ON
                    TMR2ON = 1;                   // Timer2 ON
                    TmpCnt = tempo;               // e|Zbg
                    TmpFlg = 0;                   // tOZbg
                    state = getOnpu;
                break;
            case getOnpu:               // ====== ̐ݒ ======
                Onp = p1gkf[pOnp++];              // 擾
                if(Onp == 0xFFFF){                // Ȃ̏IȂ
                    state = gkfEnd;               // 
                    break; 
                }
                tPlay = Onp & 0x000F;             // ̒擾
                Onp = Onp >> 8;                   // o
                if(Onp){                          // Ȃ
                    incWave = dW_tbl[Onp - 35];   //  JԂԂɕϊ
                    ampNext = 0x7F;               //  ʍő
                }else{                            // xȂ
                    incWave = 0;                  //  JԂ@Ȃ
                    ampNext = 0;                  //  OFF
                }
                state = onpuStart;
                break;
            case onpuStart:             // ====== ̉tJn ======
                if(TmpFlg){                       // e|҂
                    TmpFlg = 0;                   // e|tOZbg
                    amp = ampNext;                // ʍő
                    if(amp)LED3=1;                // xłȂLED_
                    AmpCnt = EnvelopeConst;       // ʌZbg
                    state = onpuPlay;
                } 
                break;
            case onpuPlay:             // ====== ̉tp ======
                if(TmpFlg){                       // e|҂
                    TmpFlg = 0;                   // e|tOZbg
                    if(tPlay-- == 2){             // IȂ
                        SltCnt = tempo - Silent;  //  ԂZbg
                        SltFlg = 0;               //  tOZbg
                        LED3=0;                   //  LED
                        state = onpuEnd;
                    }
                    if(SWdown){                   // SWꂽȂ
                        SWdown=0;                 //  SW ςݖ
                        state = gkfEnd;           //  I
                    }
                }
                break;
            case onpuEnd:             // ====== ̉tI ======
                if(SltFlg){                       // Ԃ҂
                    amp = 0;                      // OFF
                    state = getOnpu;              // ̉擾
                }
                break;
            case gkfEnd:              // ====== ỷtI ======
                    PWM2CON = 0;                  //   PWM OFF
                    TMR2ON = 0;                   //   Timer2 OFF
                    LED3=0;                       //  LED
                    state = waitStart;
                break;
        }
    }   //  while
}

// ݏu -----------------------------------------------------
void interrupt isr(void){
    if(TMR2IF){                                   // Timer2 ݂mF
        TMR2IF = 0;                               // Timer2 tO@Zbg
        accWave += incWave;                       // vZ
        if(STATUSbits.CARRY)wave ^= 1;            // Lo΁Ag`]
        if(wave)PWM2DCH = amp;                    // g`ONȂA o͂
        else PWM2DCH = 0;                         //     OFFȂAo͂Ȃ
    }
}
